> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Reconcile a refund

POST https://rest.test.zuora.com/v1/refunds/{refund-key}/reconcile
Content-Type: application/json

Reconciles a refund when receiving the gateway reconciliation request or event.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-gateway-reconciliation/post-reconcile-refund

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `refund-key` (string, required) — The refund number starting with “R-” or the unique refund ID.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTReconcileRefundRequest.

- `action` (enum, optional) — The action of the refund reconciliation. - `settle`: Sets Gateway State to "Settled" and returns the refund object as response. - `reject`: Sets Gateway State to "FailedToSettle" and handle the event according to the settings configured in the Gateway Reconciliation Configuration in Payments Settings through Zuora UI. See [Configure how to handle refund rejected events](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/M_Payment_Gateways/Gateway_Reconciliation#Configure_how_to_handle_refund_rejected_events) for details.
  - Allowed values: `settle`, `reject`
- `actionDate` (string, optional) — The date and time of the refund reconciliation action, in `yyyy-mm-dd hh:mm:ss` format.
- `gatewayReconciliationReason` (string, optional) — The reason of gateway reconciliation.
- `gatewayReconciliationStatus` (string, optional) — The status of gateway reconciliation.
- `payoutId` (string, optional) — The payout ID of the refund from the gateway side.

## Response

### 200

OK

- `accountId` (string, optional) — The ID of the customer account that the refund is for.
- `amount` (double, optional) — The total amount of the refund.
- `cancelledOn` (string, optional) — The date and time when the transaction was cancelled, in `yyyy-mm-dd hh:mm:ss` format.
- `comment` (string, optional) — Comments about the refund.
- `createdById` (string, optional) — The ID of the Zuora user who created the refund.
- `createdDate` (string, optional) — The date and time when the refund is created, in `yyyy-mm-dd hh:mm:ss` format.
- `creditMemoId` (string, optional) — The ID of the credit memo that is refunded.
- `financeInformation` (PostReconcileRefundResponseFinanceInformation, optional) — Container for the finance information related to the refund.
- `gatewayId` (string, optional) — The ID of the gateway instance that processes the refund.
- `gatewayReconciliationReason` (string, optional) — The reason of gateway reconciliation.
- `gatewayReconciliationStatus` (string, optional) — The status of gateway reconciliation.
- `gatewayResponse` (string, optional) — The message returned from the payment gateway for the refund. This message is gateway-dependent.
- `gatewayResponseCode` (string, optional) — The code returned from the payment gateway for the refund. This code is gateway-dependent.
- `gatewayState` (enum, optional) — The status of the refund in the gateway; specifically used for reconciliation.
  - Allowed values: `Settled`, `FailedToSettle`
- `id` (string, optional) — The ID of the refund.
- `markedForSubmissionOn` (string, optional) — The date and time when a refund was marked and waiting for batch submission to the payment process, in `yyyy-mm-dd hh:mm:ss` format.
- `methodType` (enum, optional) — How an external refund was issued to a customer.
  - Allowed values: `ACH`, `Cash`, `Check`, `CreditCard`, `PayPal`, `WireTransfer`, `DebitCard`, `CreditCardReferenceTransaction`, `BankTransfer`, `Other`
- `number` (string, optional) — The unique identification number of the refund. For example, R-00000001.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `paymentId` (string, optional) — The ID of the payment that is refunded.
- `paymentMethodId` (string, optional) — The unique ID of the payment method that the customer used to make the refund.
- `paymentMethodSnapshotId` (string, optional) — The unique ID of the payment method snapshot which is a copy of the particular Payment Method used in a transaction.
- `payoutId` (string, optional) — The payout ID of the refund from the gateway side.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction.
- `referenceId` (string, optional) — The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.
- `refundDate` (date, optional) — The date when the refund takes effect, in `yyyy-mm-dd` format. For example, 2020-03-01.
- `refundTransactionTime` (string, optional) — The date and time when the refund was issued, in `yyyy-mm-dd hh:mm:ss` format.
- `secondRefundReferenceId` (string, optional) — The transaction ID returned by the payment gateway if there is an additional refund.
- `settledOn` (string, optional) — The date and time when the transaction is settled, in `yyyy-mm-dd hh:mm:ss` format.
- `softDescriptor` (string, optional) — A payment gateway-specific field that maps Zuora to other gateways.
- `softDescriptorPhone` (string, optional) — A payment gateway-specific field that maps Zuora to other gateways.
- `status` (string, optional) — The status of the refund.
- `submittedOn` (string, optional) — The date and time when the refund was submitted, in yyyy-mm-dd hh:mm:ss format.
- `success` (boolean, optional) — Indicates if the request is processed successfully.
- `type` (enum, optional) — The type of the refund.
  - Allowed values: `External`, `Electronic`
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the refund.
- `updatedDate` (string, optional) — The date and time when the refund was last updated, in `yyyy-mm-dd hh:mm:ss` format.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### PostReconcileRefundResponseFinanceInformation

Container for the finance information related to the refund.

- `bankAccountAccountingCode` (string, optional) — The accounting code that maps to a bank account in your accounting system.
- `bankAccountAccountingCodeType` (string, optional) — The type of the accounting code that maps to a bank account in your accounting system.
- `transferredToAccounting` (enum, optional) — Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `unappliedPaymentAccountingCode` (string, optional) — The accounting code for the unapplied payment.
- `unappliedPaymentAccountingCodeType` (string, optional) — The type of the accounting code for the unapplied payment.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "action": "settle",
  "gatewayReconciliationStatus": "paid"
}
```

**Response**

```json
{
  "accountId": "8ad09bce83f1da020183f97e245c1c47",
  "amount": 55,
  "createdById": "8ad084a67f9c7138017fab8a8b511b5a",
  "createdDate": "2024-10-30 14:50:26",
  "financeInformation": {
    "transferredToAccounting": "No",
    "unappliedPaymentAccountingCode": "Accounts Receivable",
    "unappliedPaymentAccountingCodeType": "AccountsReceivable"
  },
  "gatewayId": "8ad095dd813e750f0181461a8e350ce7",
  "gatewayReconciliationStatus": "paid",
  "gatewayResponse": "This transaction has been approved by the gateway.",
  "gatewayResponseCode": "approve",
  "gatewayState": "Settled",
  "id": "8ad083f092d66ff90192dc309ec31b7e",
  "methodType": "CreditCard",
  "number": "R-00000025",
  "paymentId": "8ad097b48f0b078f018f0df4a6cf2ff4",
  "paymentMethodSnapshotId": "8ad083f092d66ff90192dc309e941b7d",
  "reasonCode": "Other",
  "referenceId": "5066779.708498786",
  "refundDate": "2024-10-30",
  "refundTransactionTime": "2024-10-30 14:50:27",
  "settledOn": "2024-11-13 16:07:24",
  "status": "Processed",
  "submittedOn": "2024-10-30 14:50:27",
  "success": true,
  "type": "Electronic",
  "updatedById": "8ad084a67f9c7138017fab8a8b511b5a",
  "updatedDate": "2024-11-13 16:07:24",
  "paymentGatewayNumber": null,
  "paymentNumber": "P-00001536"
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/v1/refunds/refund-key/reconcile"

payload = {
    "action": "settle",
    "gatewayReconciliationStatus": "paid"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/v1/refunds/refund-key/reconcile';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"action":"settle","gatewayReconciliationStatus":"paid"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/refunds/refund-key/reconcile"

	payload := strings.NewReader("{\n  \"action\": \"settle\",\n  \"gatewayReconciliationStatus\": \"paid\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/refunds/refund-key/reconcile")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"action\": \"settle\",\n  \"gatewayReconciliationStatus\": \"paid\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/refunds/refund-key/reconcile")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"action\": \"settle\",\n  \"gatewayReconciliationStatus\": \"paid\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/refunds/refund-key/reconcile', [
  'body' => '{
  "action": "settle",
  "gatewayReconciliationStatus": "paid"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/refunds/refund-key/reconcile");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"action\": \"settle\",\n  \"gatewayReconciliationStatus\": \"paid\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "action": "settle",
  "gatewayReconciliationStatus": "paid"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/refunds/refund-key/reconcile")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```